//
// Listener.java - Listen on a port, spawn Connections as they're accepted
//

//...simports:0:
import java.net.*;
import java.io.*;
import java.util.*;
//...e

public class Listener extends Thread
  {
  protected int      port;
  protected Textflow tf;
  protected int      buffsz;
  protected Dictionary<Integer,Connection> conns = new Hashtable<Integer,Connection>();
//...sListener:2:
public Listener(int port, Textflow tf, int buffsz)
  {
  this.port   = port;
  this.tf     = tf;
  this.buffsz = buffsz;
  }
//...e
//...srun:2:
public void run()
  {
  try
    {
    ServerSocket ss = new ServerSocket(port);
    int connIdFountain = 0;
    for ( ;; )
      {
      int connId = connIdFountain++;
      Connection conn = new Connection(ss.accept(), connId, this, buffsz);
      conns.put(new Integer(connId), conn);
      conn.forward();
      }
    }
  catch ( IOException e )
    {
    error("Cannot listen on port "+port);
    }
  }
//...e
  // Called by Connections
//...ssend:2:
public void send(String op, int connId, byte[] b, int len)
  {
  tf.send(op, port, connId, b, len);
  }
//...e
//...sconnectionEnded:2:
public void connectionEnded(int connId)
  {
  conns.remove(new Integer(connId));
  }
//...e
//...serror:2:
public void error(String s)
  {
  tf.error(s);
  }
//...e
  // Called by Textflow
//...shandle:2:
public boolean handle(String op, int connId, byte[] b)
  {
  Connection conn = conns.get(new Integer(connId));
  if ( conn != null )
    return conn.handle(op, b);
  else
    // Can happen legitimately if the client drops the connection
    // ahead of the server sending back its full response.
    // We'll assume it was correct, and we would have handled it
    return true;
  }
//...e
  }
