//
// MapPortHostPort.java - Maplets from port -> (host2,port2)
//

//...simports:0:
import java.net.*;
import java.io.*;
import java.util.*;
//...e

public class MapPortHostPort
  {
  protected Dictionary<Integer,HostPort> map = new Hashtable<Integer,HostPort>();
  public void put(String s)
    {
    StringTokenizer st = new StringTokenizer(s, ":");
    int port = Integer.parseInt(st.nextToken());
    String host2 = st.nextToken();
    int port2 = Integer.parseInt(st.nextToken());
    map.put((Integer) port, new HostPort(host2,port2));
    }
  public HostPort get(int port)
    {
    return map.get((Integer) port);
    }
  public void addMaps(String prefix, Vector<String> v)
    {
    for ( Enumeration<Integer> e = map.keys(); e.hasMoreElements(); )
      {
      Integer port = e.nextElement();
      HostPort hp = map.get(port);
      v.add(prefix);
      v.add(port.toString()+":"+hp.host+":"+hp.port);
      }
    }
  public Dictionary<Integer,Listener> startListeners(Textflow tf, int buffsz)
    {
    Dictionary<Integer,Listener> d = new Hashtable<Integer,Listener>();
    for ( Enumeration<Integer> e = map.keys(); e.hasMoreElements(); )
      {
      Integer port = e.nextElement();
      Listener l = new Listener(port.intValue(), tf, buffsz);
      d.put(port, l);
      l.start();
      }
    return d;
    }
  }
